{$G+}
unit fixmouse;
interface
uses DOS;
Procedure EnableMouseFix(Mode:Byte);
Procedure SetMouseRange(X,Y:Byte);
Procedure InitFixMouse;
Procedure DoneFixMouse;

{$IFDEF Ver60}
 Const SegB800:Word=$B800;
{$ENDIF}
implementation
var   OldInt10H:Pointer;
     OldInt33H:Pointer;
     Visibility:ShortInt;
     MouseHandler:Pointer;
     FixThisMode:Boolean;
     SaveAttr:Byte;
     OldPos:WORD;
     ModeForFix:Byte;
     SaveExitProc:Pointer;
Const AndMask:Byte=$FF;
      XORMask:Byte=$FF;
Procedure MyMouseHandler;far;external;
Procedure Int10Handler;far;external;
Procedure Int33Handler;far;external;
{$L FIXMOUSE}
Procedure DoneFixMouse;
begin
 SetIntVec($33,OldInt33H);
 SetIntVec($10,OldInt10H);
 asm
  MOV AX,0CH
  MOV CX,0
  INT 33H
 end;
 ExitProc:=SaveExitProc;
end;
Procedure EnableMouseFix(Mode:Byte);
begin
 ModeForFix:=Mode;
end;
Procedure SetMouseRange(X,Y:Byte);assembler;
asm
  MOV DL,X
  DEC DL
  SUB DH,DH
  SHL DX,3
  SUB CX,CX
  MOV AX,7
  INT 33H
  MOV DL,Y
  Dec DL
  SUB DH,DH
  SHL DX,3
  SUB CX,CX
  MOV AX,8
  INT 33H
end;
Procedure InitFixMouse;
begin
 MouseHandler:=nil;
 GetIntVec($33,OldInt33H);
 GetIntVec($10,OldInt10H);
 asm
  MOV AX,0CH
  MOV CX,7FH
  PUSH CS
  POP ES
  MOV DX,Offset MyMouseHandler
  INT 33H
 end;
 SetIntVec($33,@Int33Handler);
 SetIntVec($10,@Int10Handler);
 SaveExitProc:=ExitProc;
 ExitProc:=@DoneFixMouse;
 FixThisMode:=False;
 Visibility:=-1;
 ModeForFix:=$FF;
 OldPos:=0;
end;
begin
 InitFixMouse;
end.


